this.name = "planetFall_dockingFX";
this.author = "Thargoid";
this.copyright = "CC-by";
this.description = "FX script";
this.version = "2.31";
"use strict";

this.effectSpawned = function()
	{
	this.distance = 750;
	this.visualEffect.position = player.ship.position.add(player.ship.vectorForward.multiply(this.distance));
	this.visualEffect.orientation = player.ship.orientation;
	this.lifetime = 0;
	this.firstFrame = true;
	if(this.visualEffect.subEntities && this.visualEffect.subEntities.length > 0)
		{ // randomise the docked ships
		var listCounter = this.visualEffect.subEntities.length ; // reset the counter
		for(listCounter = this.visualEffect.subEntities.length - 1;listCounter>=0;listCounter--)
			{ if(Math.random() < 0.3) { this.visualEffect.subEntities[listCounter].remove(); } }
		}	
	this.callback = addFrameCallback(this.doorPosition.bind(this));
	}

this.effectRemoved = function()
	{ removeFrameCallback(this.callback); }
	
this.doorPosition = function(delta)
	{
	if(this.firstFrame)
		{
		this.firstFrame = false;
		return;
		}
	
	if(!player.ship.isValid || this.lifetime > 2.5) 
		{ 
		this.visualEffect.remove();
		return;
		}
	if(!delta) { return; }
	if(this.lifetime < 1)
		{ this.visualEffect.position = player.ship.position.add(player.ship.vectorForward.multiply(this.distance));}
	else
		{ this.visualEffect.position = player.ship.position.add(player.ship.vectorForward.multiply(this.distance - (((this.lifetime - 1) / 1.5) * 750))); }
	this.visualEffect.orientation = player.ship.orientation;
	this.lifetime += delta;
	return;
	}
