this.name = "planetFall_launchFX";
this.author = "Thargoid";
this.copyright = "Creative Commons: attribution, non-commercial, sharealike with clauses - see readme.txt";
this.description = "FX script";
this.version = "2.31";
"use strict";

this.effectSpawned = function()
	{
	this.distance = 250;
	this.visualEffect.position = player.ship.position.add(player.ship.vectorForward.multiply(this.distance));
	this.visualEffect.orientation = player.ship.orientation;
	this.visualEffect.orientation = this.visualEffect.orientation.rotate(this.visualEffect.vectorUp, Math.PI);
	this.lifetime = 0;
	this.firstFrame = true;
	this.callback = addFrameCallback(this.doorPosition.bind(this));
	}

this.effectRemoved = function()
	{ removeFrameCallback(this.callback); }
	
this.doorPosition = function(delta)
	{
	if(this.firstFrame)
		{
		this.firstFrame = false;
		return;
		}
		
	if(!player.ship.isValid || this.lifetime > 2.5) 
		{ 
		this.visualEffect.remove();
		return;
		}
	if(!delta) { return; }
	this.visualEffect.position = player.ship.position.add(player.ship.vectorForward.multiply(this.distance - ((this.lifetime / 2.5) * 250))); 
	this.visualEffect.orientation = player.ship.orientation;
	this.visualEffect.orientation = this.visualEffect.orientation.rotate(this.visualEffect.vectorUp, Math.PI);
	this.lifetime += delta;
	return;
	}
