this.name			= "aquatics_FX.js";
this.author			= "Thargoid";
this.copyright		= "Creative Commons Attribution - Non-Commercial - Share Alike 3.0 license with clauses - see readme.txt.";
this.description	= "Effect control script";
this.version		= "2.31";

this.shipWillDockWithStation = function(station)
	{
	if(station.hasRole("aquatics_HQ"))
		{		
		this.fx = system.addVisualEffect("aquatics_dockingFX",player.ship.position.add(player.ship.vectorForward.multiply(500)));
		this.lDoor = system.addVisualEffect("aquatics_lDoor",player.ship.position.add(player.ship.vectorForward.multiply(500)));
		this.rDoor = system.addVisualEffect("aquatics_rDoor",player.ship.position.add(player.ship.vectorForward.multiply(500)));
		} 
	}	
	
this.shipWillLaunchFromStation = function(station)
	{
	if(station.hasRole("aquatics_HQ"))
		{ this.fx = system.addVisualEffect("aquatics_launchFX",player.ship.position.add(player.ship.vectorForward.multiply(250))); } 
	}	
	
this.shipLaunchedFromStation = function(station)
	{
	if(station.hasRole("aquatics_HQ"))
		{
		this.lDoor = system.addVisualEffect("aquatics_lDoor",player.ship.position.add(player.ship.vectorForward.multiply(500)));
		this.rDoor = system.addVisualEffect("aquatics_rDoor",player.ship.position.add(player.ship.vectorForward.multiply(500)));
		this.lDoor.orientation = player.ship.orientation;
		this.rDoor.orientation = player.ship.orientation;
		}
	}
