this.name				= "aquatics_fireworks";
this.author				= "Thargoid";
this.copyright			= "Creative Commons: attribution, non-commercial, sharealike with clauses - see readme.txt";
this.description		= "Adds explosive fireworks to the ships death";
this.version			= "2.31";
"use strict";

this.shipDied = function(who, why)
	{
	this.fuelCount = 5 + Math.ceil(Math.random() * 10);
	this.largeCount = Math.ceil(Math.random() * 3);
	this.smallCount = 1 + Math.ceil(Math.random() * 5);
	if(this.ship.hasRole("aquatics_hawksbill"))
		{
		this.fuelCount *= 4; // well the Hawksbill is a fuel tanker ;)
		}

	system.addShips("aquatics_burningFuel", this.fuelCount, this.ship.position, 10);
	system.addShips("aquatics_smallWreckage", this.smallCount, this.ship.position, 5);

	if(this.largeCount > 0)
		{
		system.addShips("aquatics_largeWreckage", this.largeCount, this.ship.position, 5);
		}
	}