this.name					= "aquatics_hammerSled";
this.author					= "Thargoid";
this.copyright				= "Creative Commons: attribution, non-commercial, sharealike with clauses - see readme.txt";
this.description			= "Aquatics cargo sled script.";
this.version				= "2.31";
"use strict";

this.collided = function()
	{
	if(this.ship.energy < this.ship.maxEnergy * 0.95)
		{ this.ship.energy = this.ship.maxEnergy * 0.95; }
	}

this.collisionOn = function()
	{ delete this.collided; }

this.switchAI = function()
	{ this.ship.switchAI("dockingAI.plist"); }

this.shipDied = function(who,why)
	{
	if(!who)
		{ return; }

	this.carriedCargo = Math.ceil((Math.random() * 30) + 5);
	this.ship.spawn("cargopod", this.carriedCargo);

	this.smallCount = (Math.ceil(Math.random() * 5) - 1); // between 0-4 small pieces of wreckage
	this.fuelCount = (Math.ceil(Math.random() * 20) + 10); // between 11-30 burning fuel entities

	this.ship.spawn("aquatics_burningFuel", this.fuelCount); // spawn the burning fuel

	if(this.smallCount > 0) // if there is small wreckage
		{ this.ship.spawn("aquatics_smallWreckage", this.smallCount); } // spawn the small pieces of exploding wreckage
	}