this.name					= "aquatics_ringSegment.js";
this.author					= "Thargoid";
this.copyright				= "Creative Commons: attribution, non-commercial, sharealike with clauses - see readme.txt";
this.description			= "Positioning ship script for ring segments.";
this.version				= "2.31";
"use strict";

this.shipTakingDamage = function(amount, whom, type)
	{
	if(type && type === "scrape damage")
		{
		this.ship.position = this.$spawnPosition;
		this.ship.orientation = this.$spawnOrientation;
		if(amount) { this.ship.energy += amount; }
		}
	}
	
this.shipDied = function(whom, why)
	{
log(this.name, "whom - " + whom + ", why - " + why);	
	if(why && why !=="removed")
		{
		let newSegment = this.ship.spawnOne(this.ship.primaryRole);
		newSegment.position = this.ship.position;
		newSegment.orientation = this.ship.orientation;
		newSegment.name = this.ship.name;
		newSegment.displayName = this.ship.displayName;
		}
	}